//
// Created by zygzagz on 03.01.2021.
//

#ifndef ZAD2_BASICBLOCK_H
#define ZAD2_BASICBLOCK_H
#include "../TypeDefs.h"
#include <vector>
#include <set>

using namespace std;

class BasicBlock : public std::enable_shared_from_this<BasicBlock> {
public:

	BasicBlock() = default;;
	vector<QuadruplePtr> quads;
	vector<QuadruplePtr> afterInit;
	vector<BasicBlockPtr> in, out;
	void append(const BasicBlockPtr& after) {
		out.push_back(after);
		after->in.push_back(shared_from_this());
	}

	void addJumpInitQuad(const QuadruplePtr& q) {
		afterInit.push_back(q);
	}

	void finishQuads();
};


#endif //ZAD2_BASICBLOCK_H
